# JSP/Servlets, premiers exercices

## Question 1

Écrire une **Servlet** qui calcule et affiche la somme de deux nombres a et b passés en mode `GET`.

## Question 2
Même chose, mais la servlet passe le résultat de son calcul à une JSP pour affichage.
Cet affichage doit être quelque chose comme :

*la somme de 3 et 10 est 13*

## Question 3

On veut maintenant que la servlet (appelons-la
`Calcul3Servlet`) affiche un formulaire pour saisir les deux
nombre. Dans cette question, on ne fera pas de vérification d'erreurs.

## Question 4

Même chose, mais avec vérification d'erreur.

- les deux nombres doivent être saisis ;
- ils doivent avoir une forme correcte pour des nombres réels ;
- en cas d'erreur, le formulaire est à nouveau affiché, avec les
  valeurs saisies par l'utilisateur, ainsi que des messages d'erreur
  appropriés.

## Note technique

### Serveur embarqué par maven

Cette version fonctionne sous n'importe quel IDE, et même sans IDE !

On utilise un plugin Maven qui "embarque" un serveur jetty.

Pour lancer l'application en ligne de commandes :

~~~
mvn jetty:run
~~~

Suite au passage des servlets dans le giron d'Eclipse, il y a eu pas mal de réglages à faire par rapport à
la version précédente dans la configuration... mais ça fonctionne.

### Problèmes de versions des servlets

Oracle a « confié » la gestion des servlets à la fondation eclipse. En soit, ça n'est pas très gênant (il y a de gros acteurs de l'industrie derrière Eclipse). Mais...

L'espace de nommage `javax` étant dédié à des *extensions officielles* de Java, Oracle a demandé qu'il ne soit pas utilisé par la fondation Eclipse. Le résultat est que les packages existant ont été **renommé** en `jakarta.servlet` au lieu de `javax.servlet`. Ce qui pose pas mal de problèmes de compatibilité. En bref, pour les bibliothèques qui sont maintenues, on a souvent une ancienne version qui suppose l'utilisation de `javax.servlet` et une version récente qui utilise `jakarta.servlet`. Pour un framework aussi utilisé que Spring, c'est uniquement en Spring 3 (qui **vient** de sortir) que le passage à `jakarta.servlet` est terminé.



